Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 7391)
@@ -2,14 +2,12 @@
    !!======================================================================
    !!                       *** MODULE trcwri ***
-   !!    my_trc :   Output of my_trc tracers
+   !!     trc_wri_my_trc   :  outputs of concentration fields
    !!======================================================================
-   !! History :   1.0  !  2009-05 (C. Ethe)  Original code
+#if defined key_top && defined key_iomput
    !!----------------------------------------------------------------------
-#if defined key_top && defined key_my_trc && defined key_iomput
+   !! History :      !  2007  (C. Ethe, G. Madec)  Original code
+   !!                !  2016  (C. Ethe, T. Lovato) Revised architecture
    !!----------------------------------------------------------------------
-   !!   'key_my_trc'                                           my_trc model
-   !!----------------------------------------------------------------------
-   !! trc_wri_my_trc   :  outputs of concentration fields
-   !!----------------------------------------------------------------------
+   USE par_trc         ! passive tracers common variables
    USE trc         ! passive tracers common variables 
    USE iom         ! I/O manager
@@ -20,4 +18,9 @@
    PUBLIC trc_wri_my_trc 
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 4.0 , NEMO Consortium (2016)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -36,5 +39,5 @@
       DO jn = jp_myt0, jp_myt1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-         IF( ln_trc_wri(jn) ) CALL iom_put( cltra, trn(:,:,:,jn) )
+         CALL iom_put( cltra, trn(:,:,:,jn) )
       END DO
       !
@@ -42,17 +45,12 @@
 
 #else
-   !!----------------------------------------------------------------------
-   !!  Dummy module :                                     No passive tracer
-   !!----------------------------------------------------------------------
-   PUBLIC trc_wri_my_trc
+
 CONTAINS
-   SUBROUTINE trc_wri_my_trc                     ! Empty routine  
+
+   SUBROUTINE trc_wri_my_trc
+      !
    END SUBROUTINE trc_wri_my_trc
+
 #endif
 
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id: trcwri_my_trc.F90 3160 2011-11-20 14:27:18Z cetlod $ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!======================================================================
 END MODULE trcwri_my_trc
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7391)
@@ -8,8 +8,4 @@
    !!              -   !  2001-03  (M. Levy)  LNO3 + dia2d 
    !!             2.0  !  2007-12  (C. Deltel, G. Madec)  F90
-   !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_bio        :  
@@ -86,6 +82,4 @@
       !!                                  source      sink
       !!        
-      !!              IF 'key_diabio' defined , the biogeochemical trends
-      !!              for passive tracers are saved for futher diagnostics.
       !!---------------------------------------------------------------------
       !!
@@ -109,5 +103,5 @@
       IF( nn_timing == 1 )  CALL timing_start('p2z_bio')
       !
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          CALL wrk_alloc( jpi, jpj,     17, zw2d )
          CALL wrk_alloc( jpi, jpj, jpk, 3, zw3d )
@@ -121,5 +115,5 @@
 
       xksi(:,:) = 0.e0        ! zooplakton closure ( fbod)
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          zw2d  (:,:,:) = 0.e0
          zw3d(:,:,:,:) = 0.e0
@@ -218,25 +212,5 @@
                tra(ji,jj,jk,jpdom) = tra(ji,jj,jk,jpdom) + zdoma
 
-
-               IF( ( ln_diabio .AND. .NOT. lk_iomput ) .OR. l_trdtrc ) THEN
-                  trbio(ji,jj,jk,jp_pcs0_trd     ) = zno3phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  1) = znh4phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  2) = zphynh4
-                  trbio(ji,jj,jk,jp_pcs0_trd +  3) = zphydom
-                  trbio(ji,jj,jk,jp_pcs0_trd +  4) = zphyzoo
-                  trbio(ji,jj,jk,jp_pcs0_trd +  5) = zphydet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  6) = zdetzoo
-                  !  trend number 8 in p2zsed
-                  trbio(ji,jj,jk,jp_pcs0_trd +  8) = zzoodet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  9) = zzoobod
-                  trbio(ji,jj,jk,jp_pcs0_trd + 10) = zzoonh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 11) = zzoodom
-                  trbio(ji,jj,jk,jp_pcs0_trd + 12) = znh4no3
-                  trbio(ji,jj,jk,jp_pcs0_trd + 13) = zdomnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 14) = zdetnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 15) = zdetdom
-                  !  trend number 17 in p2zexp
-                ENDIF
-                IF( ln_diatrc .OR. lk_iomput ) THEN
+                IF( lk_iomput ) THEN
                   ! convert fluxes in per day
                   ze3t = e3t_n(ji,jj,jk) * 86400._wp
@@ -340,24 +314,5 @@
                tra(ji,jj,jk,jpdom) = tra(ji,jj,jk,jpdom) + zdoma
                !
-               IF( ( ln_diabio .AND. .NOT. lk_iomput ) .OR. l_trdtrc ) THEN
-                  trbio(ji,jj,jk,jp_pcs0_trd     ) = zno3phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  1) = znh4phy
-                  trbio(ji,jj,jk,jp_pcs0_trd +  2) = zphynh4
-                  trbio(ji,jj,jk,jp_pcs0_trd +  3) = zphydom
-                  trbio(ji,jj,jk,jp_pcs0_trd +  4) = zphyzoo
-                  trbio(ji,jj,jk,jp_pcs0_trd +  5) = zphydet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  6) = zdetzoo
-                  !  trend number 8 in p2zsed
-                  trbio(ji,jj,jk,jp_pcs0_trd +  8) = zzoodet
-                  trbio(ji,jj,jk,jp_pcs0_trd +  9) = zzoobod
-                  trbio(ji,jj,jk,jp_pcs0_trd + 10) = zzoonh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 11) = zzoodom
-                  trbio(ji,jj,jk,jp_pcs0_trd + 12) = znh4no3
-                  trbio(ji,jj,jk,jp_pcs0_trd + 13) = zdomnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 14) = zdetnh4
-                  trbio(ji,jj,jk,jp_pcs0_trd + 15) = zdetdom
-                  !  trend number 17 in p2zexp 
-                ENDIF
-                IF( ln_diatrc .OR. lk_iomput ) THEN
+                IF( lk_iomput ) THEN
                   ! convert fluxes in per day
                   ze3t = e3t_n(ji,jj,jk) * 86400._wp
@@ -389,5 +344,5 @@
       END DO
 
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          DO jl = 1, 17 
             CALL lbc_lnk( zw2d(:,:,jl),'T', 1. )
@@ -420,43 +375,4 @@
         CALL iom_put( "FNH4NO3", zw3d(:,:,:,3) )
          !
-       ELSE
-          IF( ln_diatrc ) THEN
-            !
-            trc2d(:,:,jp_pcs0_2d    ) = zw2d(:,:,1) 
-            trc2d(:,:,jp_pcs0_2d + 1) = zw2d(:,:,2) 
-            trc2d(:,:,jp_pcs0_2d + 2) = zw2d(:,:,3) 
-            trc2d(:,:,jp_pcs0_2d + 3) = zw2d(:,:,4) 
-            trc2d(:,:,jp_pcs0_2d + 4) = zw2d(:,:,5) 
-            trc2d(:,:,jp_pcs0_2d + 5) = zw2d(:,:,6) 
-            trc2d(:,:,jp_pcs0_2d + 6) = zw2d(:,:,7) 
-                     ! trend number 8 is in p2zsed.F
-            trc2d(:,:,jp_pcs0_2d +  8) = zw2d(:,:,8) 
-            trc2d(:,:,jp_pcs0_2d +  9) = zw2d(:,:,9) 
-            trc2d(:,:,jp_pcs0_2d + 10) = zw2d(:,:,10) 
-            trc2d(:,:,jp_pcs0_2d + 11) = zw2d(:,:,11) 
-            trc2d(:,:,jp_pcs0_2d + 12) = zw2d(:,:,12) 
-            trc2d(:,:,jp_pcs0_2d + 13) = zw2d(:,:,13) 
-            trc2d(:,:,jp_pcs0_2d + 14) = zw2d(:,:,14) 
-            trc2d(:,:,jp_pcs0_2d + 15) = zw2d(:,:,15) 
-            trc2d(:,:,jp_pcs0_2d + 16) = zw2d(:,:,16) 
-            trc2d(:,:,jp_pcs0_2d + 17) = zw2d(:,:,17) 
-            ! trend number 19 is in p2zexp.F
-            trc3d(:,:,:,jp_pcs0_3d    ) = zw3d(:,:,:,1) 
-            trc3d(:,:,:,jp_pcs0_3d + 1) = zw3d(:,:,:,2) 
-            trc3d(:,:,:,jp_pcs0_3d + 2) = zw3d(:,:,:,3) 
-         ENDIF
-        !
-      ENDIF
-
-      IF( ln_diabio .AND. .NOT. lk_iomput )  THEN
-         DO jl = jp_pcs0_trd, jp_pcs1_trd
-            CALL lbc_lnk( trbio(:,:,1,jl),'T', 1. )
-         END DO 
-      ENDIF
-      !
-      IF( l_trdtrc ) THEN
-         DO jl = jp_pcs0_trd, jp_pcs1_trd
-            CALL trd_trc( trbio(:,:,:,jl), jl, kt )   ! handle the trend
-         END DO
       ENDIF
 
@@ -467,5 +383,5 @@
       ENDIF
       !
-      IF( ln_diatrc .OR. lk_iomput ) THEN
+      IF( lk_iomput ) THEN
          CALL wrk_dealloc( jpi, jpj,     17, zw2d )
          CALL wrk_dealloc( jpi, jpj, jpk, 3, zw3d )
@@ -586,15 +502,4 @@
    END SUBROUTINE p2z_bio_init
 
-#else
-   !!======================================================================
-   !!  Dummy module :                                   No PISCES bio-model
-   !!======================================================================
-CONTAINS
-   SUBROUTINE p2z_bio( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
-      WRITE(*,*) 'p2z_bio: You should not have seen this print! error?', kt
-   END SUBROUTINE p2z_bio
-#endif 
-
    !!======================================================================
 END MODULE p2zbio
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7391)
@@ -10,8 +10,4 @@
    !!             3.5  !  2012-03  (C. Ethe)  Merge PISCES-LOBSTER
    !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
-   !!----------------------------------------------------------------------
    !!   p2z_exp        :  Compute loss of organic matter in the sediments
    !!----------------------------------------------------------------------
@@ -68,5 +64,4 @@
       INTEGER  ::   ji, jj, jk, jl, ikt
       REAL(wp) ::   zgeolpoc, zfact, zwork, ze3t, zsedpocd, zmaskt
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrbio
       REAL(wp), POINTER, DIMENSION(:,:)   ::  zsedpoca
       CHARACTER (len=25) :: charout
@@ -80,8 +75,4 @@
       zsedpoca(:,:) = 0.
 
-      IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, ztrbio )   ! temporary save of trends
-         ztrbio(:,:,:) = tra(:,:,:,jpno3)
-      ENDIF
 
       ! VERTICAL DISTRIBUTION OF NEWLY PRODUCED BIOGENIC
@@ -126,9 +117,5 @@
  
       ! Oa & Ek: diagnostics depending on jpdia2d !          left as example
-      IF( lk_iomput ) THEN  
-         CALL iom_put( "SEDPOC" , sedpocn )
-      ELSE
-         IF( ln_diatrc )           trc2d(:,:,jp_pcs0_2d + 18) = sedpocn(:,:)
-      ENDIF
+      IF( lk_iomput )  CALL iom_put( "SEDPOC" , sedpocn )
 
       
@@ -160,11 +147,4 @@
       ENDIF
       !
-      IF( l_trdtrc ) THEN
-         ztrbio(:,:,:) = tra(:,:,:,jpno3) - ztrbio(:,:,:)
-         jl = jp_pcs0_trd + 16
-         CALL trd_trc( ztrbio, jl, kt )   ! handle the trend
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrbio )   ! temporary save of trends
-      ENDIF
-      !
       CALL wrk_dealloc( jpi, jpj, zsedpoca)   ! temporary save of trends
 
@@ -281,15 +261,4 @@
    END FUNCTION p2z_exp_alloc
 
-#else
-   !!======================================================================
-   !!  Dummy module :                                   No PISCES bio-model
-   !!======================================================================
-CONTAINS
-   SUBROUTINE p2z_exp( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
-      WRITE(*,*) 'p2z_exp: You should not have seen this print! error?', kt
-   END SUBROUTINE p2z_exp
-#endif 
-
    !!======================================================================
 END MODULE  p2zexp
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7391)
@@ -10,8 +10,4 @@
    !!   NEMO      2.0  !  2007-12  (C. Deltel, G. Madec)  F90
    !!             3.2  !  2009-04  (C. Ethe, G. Madec)  minor optimisation + style
-   !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_opt        :   Compute the light availability in the water column
@@ -208,15 +204,4 @@
    END SUBROUTINE p2z_opt_init
 
-#else
-   !!======================================================================
-   !!  Dummy module :                                   No PISCES bio-model
-   !!======================================================================
-CONTAINS
-   SUBROUTINE p2z_opt( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
-      WRITE(*,*) 'p2z_opt: You should not have seen this print! error?', kt
-   END SUBROUTINE p2z_opt
-#endif 
-
    !!======================================================================
 END MODULE  p2zopt
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7391)
@@ -7,8 +7,4 @@
    !!              -   !  2000-12 (E. Kestenare)  clean up
    !!             2.0  !  2007-12  (C. Deltel, G. Madec)  F90 + simplifications
-   !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                                     LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2z_sed        :  Compute loss of organic matter in the sediments
@@ -66,5 +62,5 @@
       CHARACTER (len=25) :: charout
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra, ztrbio
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra
       !!---------------------------------------------------------------------
       !
@@ -79,8 +75,4 @@
       ! Allocate temporary workspace
       CALL wrk_alloc( jpi, jpj, jpk, zwork, ztra )
-      IF( l_trdtrc ) THEN
-         CALL wrk_alloc( jpi, jpj, jpk, ztrbio )
-         ztrbio(:,:,:) = tra(:,:,:,jpdet)
-      ENDIF
 
       ! sedimentation of detritus  : upstream scheme
@@ -116,25 +108,8 @@
             CALL wrk_dealloc( jpi, jpj, zw2d )
          ENDIF
-      ELSE
-         IF( ln_diatrc ) THEN 
-            CALL wrk_alloc( jpi, jpj, zw2d )
-            zw2d(:,:) =  ztra(:,:,1) * e3t_n(:,:,1) * 86400._wp
-            DO jk = 2, jpkm1
-               zw2d(:,:) = zw2d(:,:) + ztra(:,:,jk) * e3t_n(:,:,jk) * 86400._wp
-            END DO
-            trc2d(:,:,jp_pcs0_2d + 7) = zw2d(:,:)
-            CALL wrk_dealloc( jpi, jpj, zw2d )
-         ENDIF
       ENDIF
       !
-      IF( ln_diabio .AND. .NOT. lk_iomput )  trbio(:,:,:,jp_pcs0_trd + 7) = ztra(:,:,:)
       CALL wrk_dealloc( jpi, jpj, jpk, zwork, ztra )
       !
-      IF( l_trdtrc ) THEN
-         ztrbio(:,:,:) = tra(:,:,:,jpdet) - ztrbio(:,:,:)
-         jl = jp_pcs0_trd + 7
-         CALL trd_trc( ztrbio, jl, kt )   ! handle the trend
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrbio )
-      ENDIF
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -180,15 +155,4 @@
    END SUBROUTINE p2z_sed_init
 
-#else
-   !!======================================================================
-   !!  Dummy module :                                   No PISCES bio-model
-   !!======================================================================
-CONTAINS
-   SUBROUTINE p2z_sed( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
-      WRITE(*,*) 'p2z_sed: You should not have seen this print! error?', kt
-   END SUBROUTINE p2z_sed
-#endif 
-
    !!======================================================================
 END MODULE  p2zsed
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7383)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7391)
@@ -6,8 +6,4 @@
    !! History :   1.0  !            M. Levy
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
-   !!----------------------------------------------------------------------
-#if defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces_reduced'                              LOBSTER bio-model
    !!----------------------------------------------------------------------
    !!   p2zsms        :  Time loop of passive tracers sms
@@ -72,15 +68,4 @@
    END SUBROUTINE p2z_sms
 
-#else
-   !!======================================================================
-   !!  Dummy module :                                     No passive tracer
-   !!======================================================================
-CONTAINS
-   SUBROUTINE p2z_sms( kt )                   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt
-      WRITE(*,*) 'p2z_sms: You should not have seen this print! error?', kt
-   END SUBROUTINE p2z_sms
-#endif 
-
    !!======================================================================
 END MODULE p2zsms
Index: branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zagg.F90
===================================================================
--- branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zagg.F90	(revision 7391)
+++ branches/2016/dev_INGV_METO_merge_2016/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zagg.F90	(revision 7391)
@@ -0,0 +1,185 @@
+MODULE p4zagg
+   !!======================================================================
+   !!                         ***  MODULE p4zagg  ***
+   !! TOP :  PISCES  aggregation of particles
+   !!======================================================================
+   !! History :   1.0  !  2004     (O. Aumont) Original code
+   !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Change aggregation formula
+   !!             3.5  !  2012-07  (O. Aumont) Introduce potential time-splitting
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   p4z_agg       :  Compute aggregation of particles
+   !!----------------------------------------------------------------------
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE prtctl_trc      !  print control for debugging
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   p4z_agg         ! called in p4zbio.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id: p4zagg.F90 3160 2011-11-20 14:27:18Z cetlod $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE p4z_agg ( kt, knt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_agg  ***
+      !!
+      !! ** Purpose :   Compute aggregation of particles
+      !!
+      !! ** Method  : - ???
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) :: kt, knt
+      INTEGER  ::   ji, jj, jk
+      REAL(wp) ::   zagg, zagg1, zagg2, zagg3, zagg4
+      REAL(wp) ::   zaggpoc1, zaggpoc2, zaggpoc3, zaggpoc4
+      REAL(wp) ::   zaggpoc , zaggfe, zaggdoc, zaggdoc2, zaggdoc3
+      REAL(wp) ::   zaggpon , zaggdon, zaggdon2, zaggdon3
+      REAL(wp) ::   zaggpop, zaggdop, zaggdop2, zaggdop3
+      REAL(wp) ::   zaggtmp, zfact, zmax
+      CHARACTER (len=25) :: charout
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('p4z_agg')
+
+      !
+      !  Exchange between organic matter compartments due to coagulation/disaggregation
+      !  ---------------------------------------------------
+      IF( ln_p4z ) THEN
+         !
+         DO jk = 1, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  !
+                  zfact = xstep * xdiss(ji,jj,jk)
+                  !  Part I : Coagulation dependent on turbulence
+                  zagg1 = 25.9  * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
+                  zagg2 = 4452. * zfact * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
+
+                  ! Part II : Differential settling
+
+                  !  Aggregation of small into large particles
+                  zagg3 =  47.1 * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpgoc)
+                  zagg4 =  3.3  * xstep * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jppoc)
+
+                  zagg   = zagg1 + zagg2 + zagg3 + zagg4
+                  zaggfe = zagg * trb(ji,jj,jk,jpsfe) / ( trb(ji,jj,jk,jppoc) + rtrn )
+
+                  ! Aggregation of DOC to POC : 
+                  ! 1st term is shear aggregation of DOC-DOC
+                  ! 2nd term is shear aggregation of DOC-POC
+                  ! 3rd term is differential settling of DOC-POC
+                  zaggdoc  = ( ( 0.369 * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4 * trb(ji,jj,jk,jppoc) ) * zfact       &
+                  &            + 2.4 * xstep * trb(ji,jj,jk,jppoc) ) * 0.3 * trb(ji,jj,jk,jpdoc)
+                  ! transfer of DOC to GOC : 
+                  ! 1st term is shear aggregation
+                  ! 2nd term is differential settling 
+                  zaggdoc2 = ( 3.53E3 * zfact + 0.1 * xstep ) * trb(ji,jj,jk,jpgoc) * 0.3 * trb(ji,jj,jk,jpdoc)
+                  ! tranfer of DOC to POC due to brownian motion
+                  zaggdoc3 =  114. * 0.3 * trb(ji,jj,jk,jpdoc) *xstep * 0.3 * trb(ji,jj,jk,jpdoc)
+
+                  !  Update the trends
+                  tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zagg + zaggdoc + zaggdoc3
+                  tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zagg + zaggdoc2
+                  tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zaggfe
+                  tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggfe
+                  tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2 - zaggdoc3
+                  !
+                  conspoc(ji,jj,jk) = conspoc(ji,jj,jk) - zagg + zaggdoc + zaggdoc3
+                  prodgoc(ji,jj,jk) = prodgoc(ji,jj,jk) + zagg + zaggdoc2
+                  !
+               END DO
+            END DO
+         END DO
+      ELSE    ! ln_p5z
+        !
+         DO jk = 1, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  !
+                  zfact = xstep * xdiss(ji,jj,jk)
+                  !  Part I : Coagulation dependent on turbulence
+                  zaggtmp = 25.9  * zfact * trb(ji,jj,jk,jppoc)
+                  zaggpoc1 = zaggtmp * trb(ji,jj,jk,jppoc)
+                  zaggtmp = 4452. * zfact * trb(ji,jj,jk,jpgoc)
+                  zaggpoc2 = zaggtmp * trb(ji,jj,jk,jppoc)
+
+                  ! Part II : Differential settling
+   
+                  !  Aggregation of small into large particles
+                  zaggtmp =  47.1 * xstep * trb(ji,jj,jk,jpgoc)
+                  zaggpoc3 = zaggtmp * trb(ji,jj,jk,jppoc)
+                  zaggtmp =  3.3  * xstep * trb(ji,jj,jk,jppoc)
+                  zaggpoc4 = zaggtmp * trb(ji,jj,jk,jppoc)
+
+                  zaggpoc   = zaggpoc1 + zaggpoc2 + zaggpoc3 + zaggpoc4
+                  zaggpon = zaggpoc * trb(ji,jj,jk,jppon) / ( trb(ji,jj,jk,jppoc) + rtrn)
+                  zaggpop = zaggpoc * trb(ji,jj,jk,jppop) / ( trb(ji,jj,jk,jppoc) + rtrn)
+                  zaggfe = zaggpoc * trb(ji,jj,jk,jpsfe) / ( trb(ji,jj,jk,jppoc)  + rtrn )
+
+                  ! Aggregation of DOC to POC : 
+                  ! 1st term is shear aggregation of DOC-DOC
+                  ! 2nd term is shear aggregation of DOC-POC
+                  ! 3rd term is differential settling of DOC-POC
+                  zaggtmp = ( ( 0.369 * 0.3 * trb(ji,jj,jk,jpdoc) + 102.4 * trb(ji,jj,jk,jppoc) ) * zfact       &
+                  &            + 2.4 * xstep * trb(ji,jj,jk,jppoc) )
+                  zaggdoc  = zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
+                  zaggdon  = zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
+                  zaggdop  = zaggtmp * 0.3 * trb(ji,jj,jk,jpdop)
+
+                  ! transfer of DOC to GOC : 
+                  ! 1st term is shear aggregation
+                  ! 2nd term is differential settling 
+                  zaggtmp = ( 3.53E3 * zfact + 0.1 * xstep ) * trb(ji,jj,jk,jpgoc)
+                  zaggdoc2 = zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
+                  zaggdon2 = zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
+                  zaggdop2 = zaggtmp * 0.3 * trb(ji,jj,jk,jpdop)
+
+                  ! tranfer of DOC to POC due to brownian motion
+                  zaggtmp = ( 114. * 0.3 * trb(ji,jj,jk,jpdoc) ) * xstep
+                  zaggdoc3 =  zaggtmp * 0.3 * trb(ji,jj,jk,jpdoc)
+                  zaggdon3 =  zaggtmp * 0.3 * trb(ji,jj,jk,jpdon)
+                  zaggdop3 =  zaggtmp * 0.3 * trb(ji,jj,jk,jpdop)
+
+                  !  Update the trends
+                  tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zaggpoc + zaggdoc + zaggdoc3
+                  tra(ji,jj,jk,jppon) = tra(ji,jj,jk,jppon) - zaggpon + zaggdon + zaggdon3
+                  tra(ji,jj,jk,jppop) = tra(ji,jj,jk,jppop) - zaggpop + zaggdop + zaggdop3
+                  tra(ji,jj,jk,jpgoc) = tra(ji,jj,jk,jpgoc) + zaggpoc + zaggdoc2
+                  tra(ji,jj,jk,jpgon) = tra(ji,jj,jk,jpgon) + zaggpon + zaggdon2
+                  tra(ji,jj,jk,jpgop) = tra(ji,jj,jk,jpgop) + zaggpop + zaggdop2
+                  tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) - zaggfe
+                  tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zaggfe
+                  tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) - zaggdoc - zaggdoc2 - zaggdoc3
+                  tra(ji,jj,jk,jpdon) = tra(ji,jj,jk,jpdon) - zaggdon - zaggdon2 - zaggdon3
+                  tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) - zaggdop - zaggdop2 - zaggdop3
+                  !
+                  conspoc(ji,jj,jk) = conspoc(ji,jj,jk) - zaggpoc + zaggdoc + zaggdoc3
+                  prodgoc(ji,jj,jk) = prodgoc(ji,jj,jk) + zaggpoc + zaggdoc2
+                  !
+               END DO
+            END DO
+         END DO
+         !
+      ENDIF
+      !
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+         WRITE(charout, FMT="('agg')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
+      ENDIF
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('p4z_agg')
+      !
+   END SUBROUTINE p4z_agg
+
+   !!======================================================================
+END MODULE p4zagg
